routes/web.php
<?php

use App\Http\Controllers\Admin\DashboardController as AdminDashboardController;
use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\Admin\StaffController as AdminStaffController;
use App\Http\Controllers\Admin\ProductController as AdminProductController;
use App\Http\Controllers\Admin\OrderController as AdminOrderController;
use App\Http\Controllers\User\DashboardController as UserDashboardController;
use App\Http\Controllers\User\OrderController as UserOrderController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes([
    'register' => false
]);

Route::prefix('admin')->name('admin.')->group(function(){
    // Admin Routes
    Route::middleware(['auth', 'role:admin'])->group(function(){
        Route::get('/', [AdminDashboardController::class, 'index'])->name('index');
    });

    // Admin & Staff Routes
    Route::middleware(['auth', 'role:admin,staff'])->group(function(){
        Route::prefix('user')->name('user.')->group(function(){
            Route::get('/', [AdminUserController::class, 'index'])->name('index');
            Route::get('/create', [AdminUserController::class, 'create'])->name('create');
            Route::post('/create', [AdminUserController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminUserController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminUserController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminUserController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminUserController::class, 'delete'])->name('delete');
        });

        Route::prefix('staff')->name('staff.')->group(function(){
            Route::get('/', [AdminStaffController::class, 'index'])->name('index');
            Route::get('/create', [AdminStaffController::class, 'create'])->name('create');
            Route::post('/create', [AdminStaffController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminStaffController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminStaffController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminStaffController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminStaffController::class, 'delete'])->name('delete');
        });

        Route::prefix('product')->name('product.')->group(function(){
            Route::get('/', [AdminProductController::class, 'index'])->name('index');
            Route::get('/create', [AdminProductController::class, 'create'])->name('create');
            Route::post('/create', [AdminProductController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminProductController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminProductController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminProductController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminProductController::class, 'delete'])->name('delete');
        });

        Route::prefix('order')->name('order.')->group(function(){
            Route::get('/', [AdminOrderController::class, 'index'])->name('index');
            Route::get('/detail/{code}', [AdminOrderController::class, 'detail'])->name('detail');
            Route::post('/confirm', [AdminOrderController::class, 'confirm'])->name('confirm');
            Route::post('/reject', [AdminOrderController::class, 'reject'])->name('reject');
        });
    });
});

// User Routes
Route::middleware(['auth', 'role:user'])->group(function(){
    Route::get('/', [UserDashboardController::class, 'index'])->name('index');

    Route::prefix('order')->name('order.')->group(function(){
        Route::get('/', [UserOrderController::class, 'index'])->name('index');
        Route::get('/detail/{code}', [UserOrderController::class, 'detail'])->name('detail');
        Route::post('/add-to-cart', [UserOrderController::class, 'addToCart'])->name('addToCart');
        Route::get('/cart', [UserOrderController::class, 'cart'])->name('cart');
        Route::post('/checkout', [UserOrderController::class, 'checkout'])->name('checkout');
    });
});

app/Models/Order.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    use HasFactory;

    protected $fillable = [
        'invoice_code',
        'user_id',
        'total_price',
        'status'
    ];

    public function items()
    {
        return $this->hasMany(OrderItem::class, 'order_id');
    }

    public function user()
    {
        return $this->belongsTo(User::class, 'user_id')->withTrashed();
    }
}

app/Http/Controllers/Admin/OrderController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Order;
use App\Models\Product;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class OrderController extends Controller
{
    public function index(Request $request)
    {
        $orders = Order::with('items')->simplePaginate();

        return view('admins.orders.index', [
            'orders' => $orders
        ]);
    }

    public function detail(Request $request)
    {
        $order = Order::with('items')->where('invoice_code', $request->code)->first();

        return view('admins.orders.detail', [
            'order' => $order
        ]);
    }

    public function confirm(Request $request)
    {
        DB::beginTransaction();
        try {
            $order = Order::where('id', $request->id)->first();

            foreach ($order->items as $key => $item) {
                $product = Product::where('id', $item->product_id)->first();
                $product->stock = $product->stock - $item->qty;
                $product->save();
            }

            $order->status = 'completed';
            $order->save();

            DB::commit();

            return redirect()->back();
        } catch (\Throwable $th) {
            DB::rollBack();
            return redirect()->back();
        }
    }

    public function reject(Request $request)
    {
        $order = Order::where('id', $request->id)->firstOrFail();
        $order->status = 'rejected';
        $order->save();

        return redirect()->back();
    }
}

app/Http/Controllers/User/OrderController.php
<?php

namespace App\Http\Controllers\User;

use App\Http\Controllers\Controller;
use App\Models\Cart;
use App\Models\OrderItem;
use App\Models\Order;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Str;

class OrderController extends Controller
{
    public function addToCart(Request $request)
    {
        $cart = Cart::where('user_id', auth()->user()->id)->where('product_id', $request->product_id)->first();

        Cart::updateOrCreate([
            'product_id' => $request->product_id,
            'user_id' => auth()->user()->id,
        ],[
            'qty' => $request->qty + ($cart->qty ?? 0)
        ]);

        return redirect()->back();
    }

    public function cart(Request $request)
    {
        $carts = Cart::has('product')->where('user_id', auth()->user()->id)->get();

        return view('cart', [
            'carts' => $carts
        ]);
    }

    public function checkout(Request $request)
    {
        DB::beginTransaction();
        try {
            $order = Order::create([
                'invoice_code' => strtoupper(Str::random(8)),
                'user_id' => auth()->user()->id,
                'total_price' => $request->total_price,
                'status' => 'waiting_confirmation'
            ]);
    
            $carts = Cart::where('user_id', auth()->user()->id)->get();
    
            foreach ($carts as $key => $cart) {
                if ($cart->qty > $cart->product->stock) {
                    throw new Exception("Stok tidak tersedia");
                }
                
                OrderItem::create([
                    'order_id' => $order->id,
                    'price' => $cart->product->selling_price,
                    'capital_price' => $cart->product->capital_price,
                    'product_id' => $cart->product_id,
                    'qty' => $cart->qty
                ]);
            }
    
            Cart::where('user_id', auth()->user()->id)->delete();
    
            DB::commit();

            return redirect()->route('order.detail', $order->invoice_code);
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back();
        }
    }

    public function index(Request $request)
    {
        $orders = Order::with('items')->where('user_id', auth()->user()->id)->simplePaginate();

        return view('order', [
            'orders' => $orders
        ]);
    }
    
    public function detail(Request $request)
    {
        $order = Order::with('items')->where('user_id', auth()->user()->id)->where('invoice_code', $request->code)->first();

        return view('order-detail', [
            'order' => $order
        ]);
    }
}

resources/views/admins/orders/detail.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <section class="h-100 gradient-custom">
        <div class="container py-5 h-100">
            <div class="row d-flex justify-content-center align-items-center h-100">
            <div class="col-lg-10 col-xl-8">
                <div class="card" style="border-radius: 10px;">
                <div class="card-header px-4 py-5">
                    <h5 class="mb-0">Order From <span>{{ auth()->user()->name }}</span></h5>
                </div>
                <div class="card-body p-4">
                    <div class="d-flex justify-content-between align-items-center mb-4">
                    <p class="lead fw-normal mb-0">Receipt</p>
                    <p class="small mb-0">
                        Status : 
                        @if($order->status == 'waiting_confirmation')
                        Waiting Confirmation
                        @elseif($order->status == 'completed')
                        Completed
                        @elseif($order->status == 'rejected')
                        Rejected
                        @endif
                    </p>
                    </div>
                    <div class="card shadow-0 border mb-4">
                        <div class="card-body">
                            @foreach($order->items as $item)
                            <div class="row">
                                <div class="col-md-2">
                                    <img src="{{ $item->product->product_image_url }}"
                                    class="img-fluid" alt="Phone">
                                </div>
                                <div class="col-md-6 text-center d-flex justify-content-center align-items-center">
                                    <p class="mb-0">{{ $item->product->name }}</p>
                                </div>
                                <div class="col-md-2 text-center d-flex justify-content-center align-items-center">
                                    <p class="mb-0 small">Qty: {{ $item->qty }}</p>
                                </div>
                                <div class="col-md-2 text-center d-flex justify-content-center align-items-center">
                                    <p class="mb-0 small">{{ 'Rp'.number_format($item->price, 0, ',', '.') }}</p>
                                </div>
                            </div>
                            @endforeach
                        </div>
                    </div>

                    <div class="d-flex justify-content-between pt-2">
                    <p class="fw-bold mb-0">Order Details</p>
                    <p class="mb-0"><span class="fw-bold me-4">Total</span> {{ 'Rp'.number_format($order->total_price, 0, ',', '.') }}</p>
                    </div>

                    <div class="d-flex justify-content-between pt-2">
                    <p class="mb-0">Invoice Number : {{ $order->invoice_code }}</p>
                    </div>

                    <div class="d-flex justify-content-between">
                    <p class="mb-0">Invoice Date : {{ \Carbon\Carbon::parse($order->created_at)->format('d/m/Y H:i:s') }}</p>
                    </div>
                    <hr>
                    <div class="d-flex">
                        <a href="{{ route('admin.order.index') }}" class="btn btn-secondary">Back</a>
                        @if($order->status == 'waiting_confirmation')
                            <a onclick="event.preventDefault(); if(confirm('Are you sure want to reject this?')) document.getElementById('reject-form-{{ $order->id }}').submit();" class="ms-auto btn btn-danger">Reject</a>
                            <form action="{{ route('admin.order.reject') }}" method="POST" id="reject-form-{{ $order->id }}" style="display: none;">
                                @csrf
                                <input type="hidden" value="{{ $order->id }}" name="id">
                            </form>

                            <a onclick="event.preventDefault(); if(confirm('Are you sure want to confirm this?')) document.getElementById('confirm-form-{{ $order->id }}').submit();" class="ms-2 btn btn-success">Confirm</a>
                            <form action="{{ route('admin.order.confirm') }}" method="POST" id="confirm-form-{{ $order->id }}" style="display: none;">
                                @csrf
                                <input type="hidden" value="{{ $order->id }}" name="id">
                            </form>
                        @endif
                    </div>
                </div>
                </div>
            </div>
            </div>
        </div>
        </section>
    </div>
</div>
@endsection

resources/views/admins/orders/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">{{ __('My Transaction') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    <table class="table table-hover">
                        <thead>
                            <tr>
                                <th class="text-center">No</th>
                                <th>Invoice Number</th>
                                <th>Date</th>
                                <th>Buyer</th>
                                <th>Summary</th>
                                <th>Total Transaction</th>
                                <th>Status</th>
                                <th class="text-center">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($orders as $key => $order)
                            <tr>
                                <td class="text-center">{{ $orders->firstItem() + $key }}</td>
                                <td>{{ $order->invoice_code }}</td>
                                <td>{{ \Carbon\Carbon::parse($order->created_at)->format('d/m/Y H:i:s') }}</td>
                                <td>{{ $order->user->name }}</td>
                                <td>{{ $order->items->count().' Product(s)' }}</td>
                                <td>{{ 'Rp'.number_format($order->total_price, 0, ',', '.') }}</td>
                                <td>
                                @if($order->status == 'waiting_confirmation')
                                Waiting Confirmation
                                @elseif($order->status == 'completed')
                                Completed
                                @elseif($order->status == 'rejected')
                                Rejected
                                @endif
                                </td>
                                <td class="text-center">
                                    <a class="btn btn-sm btn-primary" href="{{ route('admin.order.detail', $order->invoice_code) }}">Detail</a>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection